<?php
/* 
Plugin Name: yCyclista
Plugin URI: http://www.social-ink.net/blog/ycyclista-a-plugin-for-your-wordpress-gallery-that-allows-slideshows-transitions-etc
Author URI: http://yonatanr.net
Version: 1.1
Author: Yonatan Reinberg
Description: Simple plugin to replace WP gallery with <a href="http://www.malsup.com/jquery/cycle/">JQCycle</a>. Validates fully... and stuff. <a href="options-general.php?page=yCyclista">Goto settings</a>.
 
Copyright 2010  Yonatan Reinberg (email : yoni [a t ] s o cia l-ink DOT net) - http://social-ink.net
*/

	//defaults for the options
		$twidth=get_option('thumbnail_size_w');$theight=get_option('thumbnail_size_h');
		add_option('ycyclista_fx', 'scrollLeft');			
		add_option('ycyclista_speed', '1000');	
		add_option('ycyclista_fx_anim', 'false');		
		add_option('ycyclista_thumbs_display', 'true');
		add_option('ycyclista_thumb_width', $twidth);		
		add_option('ycyclista_thumb_height', $theight);	

	//add navigation defaults
	
		add_option('ycyclista_nav_buttons', 'true');		
		add_option('ycyclista_nav_position', 'above');			
		add_option('ycyclista_nav_prev_text', 'previous');		
		add_option('ycyclista_nav_next_text', 'next');	
	
	//options/admin stuff
	add_action('admin_menu', 'ycyclista_add_menu');		//options page

		function ycylista_admin() {  
			 include('ycyclista_admin.php');  
		 }  
		 
		function ycyclista_add_menu() {  
		  add_options_page("yCyclista", "yCyclista", 1, "yCyclista", "ycylista_admin");  
		}  

	//script inits

		function yc_enqueue_scripts() {
			$plugin_url = get_option('siteurl') . '/wp-content/plugins/' . plugin_basename(dirname(__FILE__));
			wp_enqueue_script('jquery-cycle', $plugin_url . '/jquery.cycle.all.min.js', array('jquery'), '1.0' );
		}
		if (!is_admin()) {
			add_action('init', 'yc_enqueue_scripts');
		}	
		
	//theme stuff
	add_action('wp_head', 'ycyclista_jquery_header');	//header

	add_filter('post_gallery', 'ycyclista_gallery');	//override WP's gallery

		function ycyclista_jquery_header()
		{
			$plugin_url = get_option('siteurl') . '/wp-content/plugins/' . plugin_basename(dirname(__FILE__));
			
			echo "\n\n<!-- Beginning of scripting by yCyclista by Yonatan Reinberg/Social Ink (c) 2010 - http://social-ink.net - yoni@social-ink.net -->\n\n";
			
			echo '<link href="' . $plugin_url . '/ycyclista.css" rel="stylesheet" type="text/css" />' . "\n";	
			
			//build JS script here?
			///new mods!!
				//get options for animations
				$option_effect = get_option('ycyclista_fx');
				$option_speed = get_option('ycyclista_speed');
				$option_animate = get_option('ycyclista_fx_anim');
				
				//get options for desired thumbnail size
				$show_thumbnails = get_option('ycyclista_thumbs_display');
				$thumbheight =get_option('ycyclista_thumb_height');
				$thumbwidth = get_option('ycyclista_thumb_width');	

				//load the default widths to grab the thumbnail images. 
				$wp_thumbheight = get_option('thumbnail_size_h');
				$wp_thumbwidth = get_option('thumbnail_size_w');
				$wp_thumbdefaults = '-' . $wp_thumbwidth . 'x' . $wp_thumbheight;

				//navigation buttons??
				$nav_on = get_option('ycyclista_nav_buttons');
				
				//start the script here
				$scriptoutput = "<script type=\"text/javascript\">\n";
				
				$scriptoutput .= "//<![CDATA[\n\n"; //cdata to validate XHTML
				
				$scriptoutput .= "var \$j = jQuery.noConflict();\n";
				
				$scriptoutput .= "\$j(function(){\n
								\n
								//next/prev functions\n
								function addNavigations(curr, next, opts) {\n
									var index = opts.currSlide;\n
									\$j('#yc_prev')[index == 0 ? 'hide' : 'show']();\n
									\$j('#yc_next')[index == opts.slideCount - 1 ? 'hide' : 'show']();\n
								}\n
								\n
								//start script\n";
				
				$scriptoutput .= "\$j('#ycyclista_image_gallery')";
				
				if($show_thumbnails) 	//we're showing thumbnails
					$scriptoutput .= ".after('<ul id=\"yc_thumbnail_frame\">')";
								
				$scriptoutput .= ".cycle({\n";	//choose cycle features
					
					$scriptoutput .= "fx:\t'" . $option_effect . "',\n";
					$scriptoutput .= "speed:\t" . $option_speed . ",\n";
					
					if(!$option_animate) { 	//we're not animating, so we'll need more stuff

						$scriptoutput .= "timeout:\t0,\n";			

						if($nav_on) {
							$scriptoutput .= "prev:\t'#yc_prev',\n";					
							$scriptoutput .= "next:\t'#yc_next',\n";	
						}
						else
							$scriptoutput .= "next:\t'#ycyclista_image_gallery',\n";
						//$scriptoutput .= "after:\taddNavigations,\n";		// uncomment if you want funky navigations, they disappear when there's no forward or backward to go			
											
				
						if($show_thumbnails) {
						
							$scriptoutput .= "pager:\t'#yc_thumbnail_frame',\n";
							
							$scriptoutput .= "pagerAnchorBuilder: function(idx, slide) {\n
																var slideurl = slide.src;\n 
																slideurl= slideurl.split(\".jpg\").join(\"" . $wp_thumbdefaults . ".jpg\");\n
																return '<li><a href=\"#\"><img class=\"yc_img_thumbs yc_images\" height=\"" . $thumbheight . "\" width=\"" . $thumbwidth . "\" src=\"' + slideurl + '\" /></a></li>';\n
															}\n"; 		
						
						}
					
					
					}

			$scriptoutput .= "});\n";	//close cycle
			
			$scriptoutput .= "});\n";	//close JQuery ouput
			
			$scriptoutput .= "	//]]>"; //close cdata to validate XHTML
			
			$scriptoutput .= "\n</script>";
				
			echo $scriptoutput;
			
			echo "\n\n<!-- End of scripting by yCyclista by Yonatan Reinberg/Social Ink (c) 2010 - http://social-ink.net - yoni@social-ink.net -->\n\n";
		}

		function ycyclista_gallery($content) {
			
			$output .= '<div id="ycyclista_frame">';
			
			//add navigation if enabled
			$nav_on = get_option('ycyclista_nav_buttons');
			$option_animate = get_option('ycyclista_fx_anim');

			if($nav_on) { //navigation is on
				$nav_pos = get_option('ycyclista_nav_position');				
				$nav_prev = get_option('ycyclista_nav_prev_text');
				$nav_next = get_option('ycyclista_nav_next_text');	
				$navbelow = false;
				$nav_string = '<div id="yc_nav"><a id="yc_prev" href="#">' . $nav_prev . '</a> <a id="yc_next" href="#">' . $nav_next . '</a></div>';
				
				if($nav_pos == 'above') //we want to show it above or below?
					if(!$option_animate)
						$output .=	$nav_string;
				else
					$navbelow=true;
			}				
			
			$output .=	"<div id=\"ycyclista_image_gallery\">\n";
						global $wp_query;
						$thePostID = $wp_query->post->ID;	//we are weirdly outside the loop even though its overriding the gallery, which is inside... anyway, we need to get this ID.

						$args = array(
							'post_type' => 'attachment',
							'orderby' => 'menu_order ID',
							'order' => 'ASC',
							'numberposts' => -1,
							'post_status' => null,
							'post_parent' => $thePostID
							); 
						$attachments = get_posts($args);	//get all attachments
						global $attachment;
						if ($attachments) {
							foreach ($attachments as $attachment) {
								$img_title = apply_filters('the_title', $attachment->post_title);
								$img_full = wp_get_attachment_image_src($attachment->ID, 'full');
								$output .= "<img src=\"" . $img_full[0] . "\" alt=\"" . $img_title . "\" class=\"yc_img_fullsize yc_images\" width=\"" . $img_full[1] . "\" height=\"" . $img_full[2] . "\" />\n";
								echo "\n";
							}
						}


				$output .=	"\n</div>\n";
				
				//are we putting nav tools here?
				if($navbelow)
					$output .=	$nav_string;				
				
			$output .= "</div>" . $content;
							
			return $output;
		}
?>
